array<ServerInfo@> g_servers;
array<SocialInfo@> g_socials;
string g_iconColor = "\\$f05";
string g_textColor = "\\$fff ";
[Setting name="Server List URL" category="General" description="The URL of the manifest file that contains the information about all Evo servers"]
string Servers_Manifest_URL = "https://openplanet.dev/plugin/evo/config/servers";
[Setting name="Socials List URL" category="General" description="The URL of the manifest file that contains the information about all Evo socials"]
string Socials_Manifest_URL = "https://openplanet.dev/plugin/evo/config/socials";
void RenderMenu()
{
  auto app = cast<CTrackMania>(GetApp());
  auto canJoinServers = Permissions::PlayPublicClubRoom();
  if(UI::BeginMenu(g_iconColor + Icons::Gamepad + g_textColor + "Evo Esports")){
    if(UI::BeginMenu(g_iconColor + Icons::Server + g_textColor + "Join our servers", canJoinServers )){
      for(uint i = 0; i < g_servers.Length; i++) {
        if(UI::MenuItem(g_servers[i].menuLabel, "", false, canJoinServers)) {
          app.ManiaPlanetScriptAPI.OpenLink(g_servers[i].joinLink, CGameManiaPlanetScriptAPI::ELinkType::ManialinkBrowser);
        }
      }
      UI::EndMenu();
    }
    UI::Separator();
      for(uint i = 0; i < g_socials.Length; i++) {
        if(UI::MenuItem(g_socials[i].menuLabel)) {
          OpenBrowserURL(g_socials[i].url);
        }
      }
    UI::EndMenu();
  }
}

void Main()
{
  print ("Downloading latest Evo server list...");
  auto servers_response = Net::HttpGet(Servers_Manifest_URL);
  while(!servers_response.Finished()) {
    yield();
  }
  auto g_json_servers = Json::Parse(servers_response.String());
  for(uint i = 0; i < g_json_servers.Length; i++) {
    g_servers.InsertLast(ServerInfo(g_json_servers[i]));
  }
  print ("Successfully parsed Evo server list!");
  yield();
  
  print ("Downloading latest Evo socials list...");
  auto socials_response = Net::HttpGet(Socials_Manifest_URL);
  while(!socials_response.Finished()) {
    yield();
  }
  auto g_json_socials = Json::Parse(socials_response.String());
    for(uint i = 0; i < g_json_socials.Length; i++) {
    g_socials.InsertLast(SocialInfo(g_json_socials[i]));
  }
  print ("Successfully parsed Evo socials list!");
  yield();
}